this.lowborn_food_event <- this.inherit("scripts/events/event", {
	m = {},
	function create()
	{
		this.m.ID = "event.lowborn_food_event";
		this.m.Title = "During camp...";
		this.m.Cooldown = 25.0 * this.World.getTime().SecondsPerDay;
		this.m.Screens.push({
			ID = "A",
				Text = "[img]gfx/ui/events/event_61.png[/img]{Many of your men had a poor foretime with poverty and starvation. Huge piece of goluptious meat is a dream of most of them for a long time, so having such rich dinner makes them feel better. It\'s worth to be a mercenary!}",
				Image = "",
				List = [],
				Characters = [],
				Options = [
					{
						Text = "Enjoy.",
						function getResult( _event )
						{
							return 0;
						}

					}
				],
				function start( _event )
				{
					local brothers = this.World.getPlayerRoster().getAll();

					foreach( bro in brothers )
					{
						if (bro.getBackground().isLowborn())
						{
							bro.improveMood(1.0, "Eats meat as noble");
						}

						if (bro.getMoodState() >= this.Const.MoodState.Neutral)
						{
							this.List.push({
								id = 10,
								icon = this.Const.MoodStateIcon[bro.getMoodState()],
								text = bro.getName() + this.Const.MoodStateEvent[bro.getMoodState()]
							});
						}
					}
				}

			});
		}

	function onUpdateScore()
	{
		local brothers = this.World.getPlayerRoster().getAll();
		local lowborns = 0;

		foreach( bro in brothers )
		{
			if (bro.getBackground().isLowborn())
			{
				lowborns++;
			}
		}

		if (lowborns == 0)
		{
			return;
		}

		local stash = this.World.Assets.getStash().getItems();
		local food = 0;

		foreach( item in stash )
		{
			if (item != null && item.isItemType(this.Const.Items.ItemType.Food))
			{
				if (item.getID() == "supplies.smoked_ham" || 
				item.getID() == "supplies.cured_rations" ||
				item.getID() == "supplies.cured_venison")
				{
					food++;
				}
			}
		}

		if (food == 0)
		{
			return;
		}

		this.m.Score = lowborns * food;
	}

	function onPrepare()
	{
	}

	function onPrepareVariables( _vars )
	{
	}

	function onClear()
	{
	}

});