this.hexen_trophy_item <- this.inherit("scripts/items/accessory/accessory", {
	m = {},
	function create()
	{
		this.accessory.create();
		this.m.ID = "accessory.hexen_trophy";
		this.m.Name = "Hexen Trophy Necklace";
		this.m.Description = "This necklace fashioned from trophies taken of slain Hexen. Smell of strange herbs keeps owner fresh.";
		this.m.SlotType = this.Const.ItemSlot.Accessory;
		this.m.IsDroppedAsLoot = true;
		this.m.ShowOnCharacter = true;
		this.m.IconLarge = "";
		this.m.Icon = "accessory/hexe_trophy.png";
		this.m.Sprite = "hexe_trophy";
		this.m.Value = 2500;
	}

	function getSellPrice()
	{
		if (("State" in this.World) && this.World.State != null && this.World.State.getCurrentTown() != null)
		{
			local town = this.World.State.getCurrentTown();
			if (town.hasSituation("situation.abducted_children"))
			{
				return this.accessory.getSellPrice() * 5;
			}
		}

		return this.accessory.getSellPrice();
	}

	function getBuyPrice()
	{
		if (("State" in this.World) && this.World.State != null && this.World.State.getCurrentTown() != null)
		{
			local town = this.World.State.getCurrentTown();
			if (town.hasSituation("situation.abducted_children"))
			{
				return this.accessory.getBuyPrice() * 5;
			}
		}

		return this.accessory.getBuyPrice();
	}

	function getTooltip()
	{
		local result = [
			{
				id = 1,
				type = "title",
				text = this.getName()
			},
			{
				id = 2,
				type = "description",
				text = this.getDescription()
			}
		];
		result.push({
			id = 66,
			type = "text",
			text = this.getValueString()
		});

		if (this.getIconLarge() != null)
		{
			result.push({
				id = 3,
				type = "image",
				image = this.getIconLarge(),
				isLarge = true
			});
		}
		else
		{
			result.push({
				id = 3,
				type = "image",
				image = this.getIcon()
			});
		}

		result.push({
			id = 10,
			type = "text",
			icon = "ui/icons/fatigue.png",
			text = "[color=" + this.Const.UI.Color.PositiveValue + "]+4[/color] Fatigue"
		});
		return result;
	}

	function onUpdateProperties( _properties )
	{
		this.accessory.onUpdateProperties(_properties);
		_properties.Stamina += 4;
	}

});
