this.soaked_meat_item <- this.inherit("scripts/items/accessory/accessory", {
	m = {
		Charges = 3,
		MaxCharges = 3,
	},
	function create()
	{
		this.accessory.create();
		this.m.ID = "accessory.soaked_meat";
		this.m.Name = "Soaked meat";
		this.m.Description = "Peaces of drug soaked meat. Few portions to feed dog and make it stronger and faster.";
		this.m.SlotType = this.Const.ItemSlot.Bag;
		this.m.IsAllowedInBag = true;
		this.m.IsDroppedAsLoot = false;
		this.m.ShowOnCharacter = false;
		this.m.IconLarge = "";
		this.m.Icon = "accessory/soaked_meat.png";
		this.m.StaminaModifier = -5;
		this.m.Value = 200;
	}

	function getTooltip()
	{
		local result = this.accessory.getTooltip();

		result.push({
			id = 10,
			type = "text",
			icon = "ui/icons/special.png",
			text = "Used whenever you unleash hound it gains Colossus, Dodge, Crippling Strikes and Fast Adaption perks."
		});

		result.push({
			id = 10,
			type = "text",
			icon = "ui/icons/special.png",
			text = "Has [color=" + this.Const.UI.Color.PositiveValue + "]" + this.m.Charges + "[/color] charges (up to 3)."
		});

		return result;
	}

	function onSerialize( _out )
	{
		this.item.onSerialize(_out);
		_out.writeU16(this.m.Charges);
	}

	function onDeserialize( _in )
	{
		this.item.onDeserialize(_in);
		this.m.Charges = _in.readU16();
	}

	function getCharges()
	{
		return this.m.Charges;
	}

	function useCharge(dog_entity)
	{
		dog_entity.getSkills().add(this.new("scripts/skills/perks/perk_colossus"));
		dog_entity.getSkills().add(this.new("scripts/skills/perks/perk_dodge"));
		dog_entity.getSkills().add(this.new("scripts/skills/perks/perk_crippling_strikes"));
		dog_entity.getSkills().add(this.new("scripts/skills/perks/perk_fast_adaption"));

		this.m.Charges--;

		if (this.m.Charges == 0)
		{
			this.removeSelf();
		}
	}
});