this.dodge_effect <- this.inherit("scripts/skills/skill", {
	m = {
		Bonus = 0
	},
	function create()
	{
		this.m.ID = "effects.dodge";
		this.m.Name = "Dodge";
		this.m.Description = "Quick reflexes allow this character to gain melee and ranged defense per each tile moved.";
		this.m.Icon = "ui/perks/perk_01.png";
		this.m.IconMini = "perk_01_mini";
		this.m.Type = this.Const.SkillType.StatusEffect;
		this.m.IsActive = false;
	}

	function getTooltip()
	{
		return [
			{
				id = 1,
				type = "title",
				text = this.getName()
			},
			{
				id = 2,
				type = "description",
				text = this.getDescription()
			},
			{
				id = 10,
				type = "text",
				icon = "ui/icons/melee_defense.png",
				text = "[color=" + this.Const.UI.Color.PositiveValue + "]+" + this.m.Bonus + "[/color] Melee Defense"
			},
			{
				id = 11,
				type = "text",
				icon = "ui/icons/ranged_defense.png",
				text = "[color=" + this.Const.UI.Color.PositiveValue + "]+" + this.m.Bonus + "[/color] Ranged Defense"
			}
		];
	}

	function onMovementStep(_tile, _levelDifference)
	{
		this.m.Bonus = this.Math.min(20, this.m.Bonus + 2);
	}

	function onTurnStart()
	{
		this.m.Bonus = this.Math.max(0, this.m.Bonus - (this.m.IsTalented ? 2 : 3));
	}

	function onAfterUpdate( _properties )
	{
		if (!this.getContainer().getActor().isPlacedOnMap())
		{
			this.m.IsHidden = true;
			return;
		}

		if (this.m.Bonus > 0)
		{
			_properties.MeleeDefense += this.m.Bonus;
			_properties.RangedDefense += this.m.Bonus;
			this.m.IsHidden = false;
		}
		else
		{
			this.m.IsHidden = true;
		}
	}

	function onCombatFinished()
	{
		this.m.Bonus = 0;
		this.m.IsHidden = true;
	}
});
