this.perk_coup_de_grace <- this.inherit("scripts/skills/skill", {
	m = {
		Bonus = 0.2
	},
	function create()
	{
		this.m.ID = "perk.coup_de_grace";
		this.m.Name = this.Const.Strings.PerkName.CoupDeGrace;
		this.m.Description = this.Const.Strings.PerkDescription.CoupDeGrace;
		this.m.Icon = "ui/perks/perk_32.png";
		this.m.Type = this.Const.SkillType.Perk;
		this.m.Order = this.Const.SkillOrder.Perk;
		this.m.IsActive = false;
		this.m.IsStacking = false;
		this.m.IsHidden = false;
	}

	function onAnySkillUsed( _skill, _targetEntity, _properties )
	{
		if (_targetEntity == null)
		{
			return;
		}

		if (_targetEntity.getSkills().hasSkillOfType(this.Const.SkillType.TemporaryInjury))
		{
			_properties.DamageTotalMult *= (1 + this.m.Bonus);
		}
	}

	function onTargetKilled( _targetEntity, _skill )
	{
		if (!this.m.IsTalented)
		{
			return;
		}

		if (this.getContainer().getActor().isAlliedWith(_targetEntity))
		{
			return;
		}

		this.m.Bonus = this.Math.min(0.5, this.m.Bonus + 0.05)
	}

	function onCombatStarted()
	{
		this.m.Bonus = 0.2;
	}

	function onCombatFinished()
	{
		this.m.Bonus = 0.2;
		this.skill.onCombatFinished();
	}
});
