this.perk_fearsome <- this.inherit("scripts/skills/skill", {
	m = {
		Bonus = 0
	},
	function create()
	{
		this.m.ID = "perk.fearsome";
		this.m.Name = this.Const.Strings.PerkName.Fearsome;
		this.m.Description = this.Const.Strings.PerkDescription.Fearsome;
		this.m.Icon = "ui/perks/perk_27.png";
		this.m.Type = this.Const.SkillType.Perk | this.Const.SkillType.StatusEffect;
		this.m.Order = this.Const.SkillOrder.Perk;
		this.m.IsActive = false;
		this.m.IsStacking = false;
		this.m.IsHidden = false;
	}

	function getTooltip()
	{
		local threat = this.Math.floor(this.getContainer().getActor().getBravery() * 0.3);
		return [
			{
				id = 1,
				type = "title",
				text = this.getName()
			},
			{
				id = 2,
				type = "description",
				text = "Reduces Resolve of any opponent engaged in melee based on your resolve"
			},
			{
				id = 10,
				type = "text",
				icon = "ui/icons/special.png",
				text = "Reduces the Resolve of any opponent engaged in melee by [color=" + this.Const.UI.Color.NegativeValue + "]-" + threat + "[/color]"
			}
		];
	}

	function onUpdated( _properties )
	{
		local threat = this.Math.floor(this.getContainer().getActor().getBravery() * 0.3);
		_properties.Threat += threat;
	}
});
