this.perk_mastery_weapon <- this.inherit("scripts/skills/skill", {
	m = {
		MeleeBonus = 0,
		RangedBonus = 0
	},
	function create()
	{
		this.m.ID = "perk.mastery.weapon";
		this.m.Name = "Weapon Mastery";
		this.m.Description = "Gain Melee Skill based on Ranged Skill, gain Ranged Skill based on Melee Skill. Gain extra bonus being mastery in weapons.";
		this.m.Icon = "ui/perks/perk_weapon_mastery.png";
		this.m.Type = this.Const.SkillType.Perk | this.Const.SkillType.StatusEffect;
		this.m.Order = this.Const.SkillOrder.Perk;
		this.m.IsActive = false;
		this.m.IsStacking = false;
		this.m.IsHidden = false;
	}

	function getTooltip()
	{
		return [
			{
				id = 1,
				type = "title",
				text = this.getName()
			},
			{
				id = 2,
				type = "description",
				text = this.getDescription()
			},
			{
				id = 10,
				type = "text",
				icon = "ui/icons/melee_skill.png",
				text = "[color=" + this.Const.UI.Color.PositiveValue + "]+" + this.m.MeleeBonus + "[/color] Melee Skill"
			},
			{
				id = 11,
				type = "text",
				icon = "ui/icons/ranged_skill.png",
				text = "[color=" + this.Const.UI.Color.PositiveValue + "]+" + this.m.RangedBonus + "[/color] Ranged Skill"
			}
		];
	}

	function onUpdate( _properties )
	{
		this.m.MeleeBonus = this.Math.ceil(_properties.getRangedSkill() * 0.1);
		this.m.RangedBonus = this.Math.ceil(_properties.getMeleeSkill() * 0.1);
	}

	function onAfterUpdate( _properties )
	{
		local extra = -1 +
		(_properties.IsSpecializedInBows ? 1: 0) +
		(_properties.IsSpecializedInCrossbows ? 1: 0) +
		(_properties.IsSpecializedInThrowing ? 1: 0);

		this.m.RangedBonus += this.Math.max(0, extra * 5);

		extra = -1 +
		(_properties.IsSpecializedInSwords ? 1 : 0) +
		(_properties.IsSpecializedInCleavers ? 1 : 0) +
		(_properties.IsSpecializedInMaces ? 1 : 0) +
		(_properties.IsSpecializedInHammers ? 1 : 0) +
		(_properties.IsSpecializedInAxes ? 1 : 0) +
		(_properties.IsSpecializedInFlails ? 1 : 0) +
		(_properties.IsSpecializedInSpears ? 1 : 0) +
		(_properties.IsSpecializedInPolearms ? 1 : 0) +
		(_properties.IsSpecializedInDaggers ? 1 : 0);

		this.m.MeleeBonus += this.Math.max(0, extra * 5);

		_properties.MeleeSkill += this.m.MeleeBonus;
		_properties.RangedSkill += this.m.RangedBonus;
	}
});