this.perk_quick_hands <- this.inherit("scripts/skills/skill", {
	m = {
		LastItemType = 0,
		HaveBonus = false
	},
	function create()
	{
		this.m.ID = "perk.quick_hands";
		this.m.Name = this.Const.Strings.PerkName.QuickHands;
		this.m.Description = "Maybe use this instead? This character has quick hands and can still swap an item for free this turn.";
		this.m.Icon = "ui/perks/perk_39.png";
		this.m.Type = this.Const.SkillType.Perk | this.Const.SkillType.StatusEffect;
		this.m.Order = this.Const.SkillOrder.Perk | this.Const.SkillOrder.Any;
		this.m.IsActive = false;
		this.m.IsStacking = false;
		this.m.IsHidden = false;
	}

	function onUpdate( _properties )
	{
		if (this.getContainer().getActor().isPlayerControlled() && this.getContainer().getActor().isPlacedOnMap() && this.getContainer().getActor().getItems().m.ActionCost == 0)
		{
			this.m.IsHidden = false;
		}
		else
		{
			this.m.IsHidden = true;
		}
	}

	function onCombatStarted()
	{
		this.skill.onCombatStarted();

		if (this.getContainer().getActor().isPlayerControlled())
		{
			this.m.IsHidden = false;
		}

		if (this.m.IsTalented)
		{
			local weapon = this.getContainer().getActor().getItems().getItemAtSlot(this.Const.ItemSlot.Mainhand);
			if (weapon != null && weapon.isItemType(this.Const.Items.ItemType.RangedWeapon))
			{
				this.m.LastItemType = this.Const.Items.ItemType.RangedWeapon;
			}
			else
			{
				this.m.LastItemType = this.Const.Items.ItemType.MeleeWeapon;
			}
		}
		
	}

	function onCombatFinished()
	{
		this.skill.onCombatFinished();
		this.m.IsHidden = true;

		this.m.LastItemType = 0;
	}

	function onItemEquiped(_item)
	{
		if (!this.m.IsTalented || _item == null)
		{
			return;
		}

		if (_item.isItemType(this.m.LastItemType) || _item.getSlotType() != this.Const.ItemSlot.Mainhand)
		{
			return;
		}

		this.m.HaveBonus = true;
		this.m.LastItemType = this.m.LastItemType == this.Const.Items.ItemType.RangedWeapon ? this.Const.Items.ItemType.MeleeWeapon : this.Const.Items.ItemType.RangedWeapon;
	}

	function onAnySkillUsed( _skill, _targetEntity, _properties )
	{
		if (this.m.HaveBonus)
		{
			_properties.MeleeSkill += 20;
			_properties.RangedSkill += 20;
		}
	}

	function onTargetHit( _skill, _targetEntity, _bodyPart, _damageInflictedHitpoints, _damageInflictedArmor )
	{
		if (_targetEntity != null && this.isKindOf(_targetEntity, "actor"))
		{
			this.m.HaveBonus = false;
		}
	}

	function onTargetMissed( _skill, _targetEntity )
	{
		if (_targetEntity != null && this.isKindOf(_targetEntity, "actor"))
		{
			this.m.HaveBonus = false;
		}
	}
});
