this.perk_recover <- this.inherit("scripts/skills/skill", {
	m = {},
	function create()
	{
		this.m.ID = "perk.recover";
		this.m.Name = this.Const.Strings.PerkName.Recover;
		this.m.Description = this.Const.Strings.PerkDescription.Recover;
		this.m.Icon = "ui/perks/perk_21.png";
		this.m.Type = this.Const.SkillType.Perk;
		this.m.Order = this.Const.SkillOrder.Perk;
		this.m.IsActive = false;
		this.m.IsStacking = false;
		this.m.IsHidden = false;
	}

	function onAdded()
	{
		if (!this.m.Container.hasSkill("actives.recover"))
		{
			this.m.Container.add(this.new("scripts/skills/actives/recover_skill"));
		}
	}

	function onTurnEnd()
	{
		if (this.m.IsTalented)
		{
			local actor = this.getContainer().getActor();
			local recoverValue = actor.getActionPoints() * 5.01;
			actor.setFatigue(actor.getFatigue() * (1.0 - recoverValue / 100));
		}
	}

	function onRemoved()
	{
		this.m.Container.removeByID("actives.recover");
	}

});
