this.battle_rage_spec <- this.inherit("scripts/skills/skill", {
	m = {
	},
	function create()
	{
		this.m.ID = "perk.battle_rage_spec";
		this.m.Name = "Battle Rage";
		this.m.Description = "To battle! Can\'t make Wait action and taking damage provides free revange attack in melee.";
		this.m.Icon = "ui/perks/battle_rage.png";
		this.m.Type = this.Const.SkillType.Perk | this.Const.SkillType.StatusEffect;
		this.m.Order = this.Const.SkillOrder.Perk | this.Const.SkillType.StatusEffect;
		this.m.IsActive = false;
		this.m.IsStacking = false;
		this.m.IsHidden = false;
	}

	function getDescription()
	{
		return "This character prefers in rage. He can\'t make Wait action and makes revange attack when take damage.";
	}

	function onAfterDamageReceived( _attacker, _damageHitpoints, _damageArmor, _skill = null )
	{
		local actor = this.getContainer().getActor();

		if (_damageHitpoints == 0 || actor == null || _skill == null)
		{
			return;
		}

		if (!_skill.isAttack() || actor.getMoraleState() == this.Const.MoraleState.Fleeing)
		{
			return;
		}

		local _targets = getTargets(actor)
		if (_targets.len() == 0)
		{
			return;
		}

		local _target = _targets[this.Math.rand(0, _targets.len() - 1)];
		local _skills = actor.getSkills().getAttackSkillsForTarget(actor.getTile(), _target.getTile());
		if (_skills.len() == 0)
		{
			return;
		}

		local _revangeSkill = _skills[this.Math.rand(0, _skills.len() - 1)];
		local info = {
				Skill = _revangeSkill,
				TargetTile = _target.getTile()
			};

		this.Time.scheduleEvent(this.TimeUnit.Virtual, this.Const.Combat.RiposteDelay * 3, this.onExtraAttack.bindenv(this), info);
	}

	function onTurnStart()
	{
		local actor = this.getContainer().getActor();
		if (actor != null)
		{
			actor.setWaitActionSpent(true);
		}
	}

	function onAfterUpdate( _properties )
	{
		_properties.InitiativeAfterWaitMult = 1.0;
	}

	function onExtraAttack( _info )
	{
		local actor = this.getContainer().getActor();
		if (actor != null && actor.isAlive())
		{
			_info.Skill.useForFree(_info.TargetTile);
		}
	}

	function getTargets(actor)
	{
		local targets = [];
		local tile = actor.getTile();
		for( local i = 0; i != 6; i = ++i )
		{
			if (!tile.hasNextTile(i))
			{
			}
			else
			{
				local next = tile.getNextTile(i);

				if (next.IsOccupiedByActor && this.Math.abs(next.Level - tile.Level) <= 1 && !next.getEntity().isAlliedWith(actor))
				{
					targets.push(next.getEntity());
				}
			}
		}

		return targets;
	}
});