/*
 *  @Project:		Battle Brothers
 *	@Company:		Overhype Studios
 *
 *	@Copyright:		(c) Overhype Studios | 2013 - 2017
 * 
 *  @Author:		Overhype Studios
 *  @Date:			18.02.2017
 *  @Description:	Global Tooltip UI Identifier
 */


/*
	Constants
 */
var TooltipIdentifier =
{
	CharacterName: 'CharacterName',
	CharacterNameAndTitles: 'CharacterNameAndTitles',

	Assets:
	{
        Money: 'assets.Money',
        InitialMoney: 'assets.InitialMoney',
        TryoutMoney: 'assets.TryoutMoney',
        Fee: 'assets.Fee',
        DailyMoney: 'assets.DailyMoney',
        Food: 'assets.Food',
        DailyFood: 'assets.DailyFood',
        Ammo: 'assets.Ammo',
        Supplies: 'assets.Supplies',
        Medicine: 'assets.Medicine',
		Brothers: 'assets.Brothers',
		BusinessReputation: 'assets.BusinessReputation',
		MoralReputation: 'assets.MoralReputation',
		Ambition: 'assets.Ambition'
    },

	Stash:
	{
	    FreeSlots: 'stash.FreeSlots',
	    ActiveRoster: 'stash.ActiveRoster'
    },

	Ground:
	{
        Slots: 'ground.Slots'
    },

	CharacterStats:
	{
		ActionPoints:		'character-stats.ActionPoints',
		Hitpoints:			'character-stats.Hitpoints',
		Morale:				'character-stats.Morale',
		Fatigue:			'character-stats.Fatigue',
		MaximumFatigue:		'character-stats.MaximumFatigue',
		ArmorHead:			'character-stats.ArmorHead',
		ArmorBody:			'character-stats.ArmorBody',

		MeleeSkill:			'character-stats.MeleeSkill',
		RangeSkill:			'character-stats.RangeSkill',
		MeleeDefense:		'character-stats.MeleeDefense',
		RangeDefense:		'character-stats.RangeDefense',
		SightDistance:		'character-stats.SightDistance',
		RegularDamage:		'character-stats.RegularDamage',
		CrushingDamage:		'character-stats.CrushingDamage',
		ChanceToHitHead:	'character-stats.ChanceToHitHead',
		Initiative:			'character-stats.Initiative',
		Bravery:			'character-stats.Bravery',

		Talent:				'character-stats.Talent',

		Undefined:			'character-stats.Undefined'
	},

	CharacterBackgrounds:
	{
		Generic: 'character-backgrounds.generic'
    },

	CharacterLevels:
	{
        Generic: 'character-levels.generic'
    },

	MenuScreen:
	{
		LoadCampaign:
		{
            LoadButton: 'menu-screen.load-campaign.LoadButton',
            CancelButton: 'menu-screen.load-campaign.CancelButton',
            DeleteButton: 'menu-screen.load-campaign.DeleteButton'
        },

		SaveCampaign:
		{
            LoadButton: 'menu-screen.save-campaign.LoadButton',
            CancelButton: 'menu-screen.save-campaign.CancelButton',
            DeleteButton: 'menu-screen.save-campaign.DeleteButton'
        },

		NewCampaign:
		{
			CompanyName: 'menu-screen.new-campaign.CompanyName',
			Seed: 'menu-screen.new-campaign.Seed',
			DifficultyEasy: 'menu-screen.new-campaign.EasyDifficulty',
			DifficultyNormal: 'menu-screen.new-campaign.NormalDifficulty',
			DifficultyHard: 'menu-screen.new-campaign.HardDifficulty',
			EconomicDifficultyEasy: 'menu-screen.new-campaign.EasyDifficultyEconomic',
			EconomicDifficultyNormal: 'menu-screen.new-campaign.NormalDifficultyEconomic',
			EconomicDifficultyHard: 'menu-screen.new-campaign.HardDifficultyEconomic',
			BudgetDifficultyEasy: 'menu-screen.new-campaign.EasyDifficultyBudget',
			BudgetDifficultyNormal: 'menu-screen.new-campaign.NormalDifficultyBudget',
			BudgetDifficultyHard: 'menu-screen.new-campaign.HardDifficultyBudget',
			Ironman: 'menu-screen.new-campaign.Ironman',
			EvilRandom: 'menu-screen.new-campaign.EvilRandom',
			EvilNone: 'menu-screen.new-campaign.EvilNone',
			EvilWar: 'menu-screen.new-campaign.EvilWar',
			EvilGreenskins: 'menu-screen.new-campaign.EvilGreenskins',
			EvilUndead: 'menu-screen.new-campaign.EvilUndead',
			EvilExtraLate: 'menu-screen.new-campaign.EvilExtraLate',
            EvilPermanentDestruction: 'menu-screen.new-campaign.EvilPermanentDestruction',
            StartingScenario: 'menu-screen.new-campaign.StartingScenario'
		},

		Options:
		{
			DepthOfField: 'menu-screen.options.DepthOfField',
			UIScale: 'menu-screen.options.UIScale',
			SceneScale: 'menu-screen.options.SceneScale',

			EdgeOfScreen: 'menu-screen.options.EdgeOfScreen',
			DragWithMouse: 'menu-screen.options.DragWithMouse',
			HardwareMouse: 'menu-screen.options.HardwareMouse',

			CameraFollow: 'menu-screen.options.CameraFollow',
			CameraAdjust: 'menu-screen.options.CameraAdjust',
			StatsOverlays: 'menu-screen.options.StatsOverlays',
			OrientationOverlays: 'menu-screen.options.OrientationOverlays',
			MovementPlayer: 'menu-screen.options.MovementPlayer',
			MovementAI: 'menu-screen.options.MovementAI',
			AutoLoot: 'menu-screen.options.AutoLoot',
			AlwaysHideTrees: 'menu-screen.options.AlwaysHideTrees',
			AutoEndTurns: 'menu-screen.options.AutoEndTurns',
            RestoreEquipment: 'menu-screen.options.RestoreEquipment',
            AutoPauseAfterCity: 'menu-screen.options.AutoPauseAfterCity',

            HardwareSound: 'menu-screen.options.HardwareSound',
		}
    },

	TacticalScreen:
	{

		Topbar:
		{
			EventLogModule:
			{
				ExpandButton: 'tactical-screen.topbar.event-log-module.ExpandButton'
			},

			RoundInformationModule:
			{
                BrothersCounter: 'tactical-screen.topbar.round-information-module.BrothersCounter',
                EnemiesCounter: 'tactical-screen.topbar.round-information-module.EnemiesCounter',
                RoundCounter: 'tactical-screen.topbar.round-information-module.RoundCounter'
            },

			OptionsBarModule:
			{
				CenterButton: 'tactical-screen.topbar.options-bar-module.CenterButton',
				SwitchMapOrientationButton: 'tactical-screen.topbar.options-bar-module.SwitchMapOrientationButton',
                SwitchMapLevelUpButton: 'tactical-screen.topbar.options-bar-module.SwitchMapLevelUpButton',
                SwitchMapLevelDownButton: 'tactical-screen.topbar.options-bar-module.SwitchMapLevelDownButton',
                ToggleStatsOverlaysButton: 'tactical-screen.topbar.options-bar-module.ToggleStatsOverlaysButton',
                TreesButton: 'tactical-screen.topbar.options-bar-module.ToggleTreesButton',
                FleeButton: 'tactical-screen.topbar.options-bar-module.FleeButton',
                QuitButton: 'tactical-screen.topbar.options-bar-module.QuitButton'
            }
        },

		TurnSequenceBarModule:
		{
            EndTurnAllButton: 'tactical-screen.turn-sequence-bar-module.EndTurnAllButton',
            EndTurnButton: 'tactical-screen.turn-sequence-bar-module.EndTurnButton',
			WaitTurnButton: 'tactical-screen.turn-sequence-bar-module.WaitTurnButton',
			OpenInventoryButton: 'tactical-screen.turn-sequence-bar-module.OpenInventoryButton'
		}
	},

	TacticalCombatResultScreen:
	{
        LeaveButton: 'tactical-combat-result-screen.LeaveButton',

		StatisticsPanel:
		{
            LeveledUp: 'tactical-combat-result-screen.statistics-panel.LeveledUp',
            DaysWounded: 'tactical-combat-result-screen.statistics-panel.DaysWounded',
            KillsValue: 'tactical-combat-result-screen.statistics-panel.KillsValue',
            XPReceivedValue: 'tactical-combat-result-screen.statistics-panel.XPReceivedValue',
            DamageDealtValue: 'tactical-combat-result-screen.statistics-panel.DamageDealtValue',
            DamageReceivedValue: 'tactical-combat-result-screen.statistics-panel.DamageReceivedValue',

        },

		LootPanel:
		{
            LootAllItemsButton: 'tactical-combat-result-screen.loot-panel.LootAllItemsButton'
        }
    },

	WorldScreen:
	{
		Topbar:
		{
			TimePauseButton: 'world-screen.topbar.TimePauseButton',
			TimeNormalButton: 'world-screen.topbar.TimeNormalButton',
			TimeFastButton: 'world-screen.topbar.TimeFastButton',

			OptionsModule:
			{
                ActiveContractButton: 'world-screen.topbar.options-module.ActiveContractButton',
                RelationsButton: 'world-screen.topbar.options-module.RelationsButton',
                CameraLockButton: 'world-screen.topbar.options-module.CameraLockButton',
				CenterButton: 'world-screen.topbar.options-module.CenterButton',       
				TrackingButton: 'world-screen.topbar.options-module.TrackingButton',  
				CampButton: 'world-screen.topbar.options-module.CampButton',
				ObituaryButton: 'world-screen.topbar.options-module.ObituaryButton',
				BudgetButton: 'world-screen.topbar.options-module.BudgetButton',
				QuitButton: 'world-screen.topbar.options-module.QuitButton'
            }
        },

		ActiveContractPanelModule:
		{
            ToggleVisibilityButton: 'world-screen.active-contract-panel-module.ToggleVisibilityButton'
		},

		Obituary:
		{
			ColumnName: 'world-screen.obituary.ColumnName',
			ColumnTime: 'world-screen.obituary.ColumnTime',
			ColumnBattles : 'world-screen.obituary.ColumnBattles',
			ColumnKills : 'world-screen.obituary.ColumnKills',
			ColumnKilledBy: 'world-screen.obituary.ColumnKilledBy'
		}
    },

	WorldTownScreen:
	{
		MainDialogModule:
		{
			Contract: 'world-town-screen.main-dialog-module.Contract',
			ContractNegotiated: 'world-town-screen.main-dialog-module.ContractNegotiated',
			ContractDisabled: 'world-town-screen.main-dialog-module.ContractDisabled',
			ContractLocked: 'world-town-screen.main-dialog-module.ContractLocked',
			LeaveButton: 'world-town-screen.main-dialog-module.LeaveButton'			
        },

        TaxiDermistDialogModule:
        {
            CraftButton: 'world-town-screen.taxidermist-dialog-module.CraftButton'
        },

		HireDialogModule:
		{
            HireButton: 'world-town-screen.hire-dialog-module.HireButton',
            TryoutButton: 'world-town-screen.hire-dialog-module.TryoutButton',
            LeaveButton: 'world-town-screen.hire-dialog-module.LeaveButton',
            UnknownTraits: 'world-town-screen.hire-dialog-module.UnknownTraits',
        },

		ShopDialogModule:
		{
            LeaveButton: 'world-town-screen.shop-dialog-module.LeaveButton'
        },

		TravelDialogModule:
		{
			LeaveButton: 'world-town-screen.travel-dialog-module.LeaveButton',
			TravelButton: 'world-town-screen.travel-dialog-module.TravelButton'
        }
	},

	RelationsScreen:
	{
		Relations: 'world-relations-screen.Relations',
	},

	WorldGameFinishScreen:
	{
		DialogModule:
		{
            QuitButton: 'world-game-finish-screen.dialog-module.QuitButton'
        }
    },

	CharacterScreen:
	{
		LeftPanelHeaderModule:
		{
            ChangeNameAndTitle: 'character-screen.left-panel-header-module.ChangeNameAndTitle',
            Experience: 'character-screen.left-panel-header-module.Experience',
			Level: 'character-screen.left-panel-header-module.Level',
			Dismiss: 'character-screen.left-panel-header-module.Dismiss'
        },

		PaperdollModule:
		{

		},

		RightPanelHeaderModule:
		{
            InventoryButton: 'character-screen.right-panel-header-module.InventoryButton',
            PerksButton: 'character-screen.right-panel-header-module.PerksButton',
            CloseButton: 'character-screen.right-panel-header-module.CloseButton',
			SortButton: 'character-screen.right-panel-header-module.SortButton',
			FilterAllButton: 'character-screen.right-panel-header-module.FilterAllButton',
			FilterWeaponsButton: 'character-screen.right-panel-header-module.FilterWeaponsButton',
			FilterArmorButton: 'character-screen.right-panel-header-module.FilterArmorButton',
            FilterMiscButton: 'character-screen.right-panel-header-module.FilterMiscButton',
            FilterUsableButton: 'character-screen.right-panel-header-module.FilterUsableButton',
			FilterMoodButton: 'character-screen.right-panel-header-module.FilterMoodButton'
        },

		BattleStartFooterModule:
		{
            StartBattleButton: 'character-screen.battle-start-footer-module.StartBattleButton'
        },

		LevelUpPopupDialog:
		{
            StatIncreasePoints: 'character-screen.levelup-popup-dialog.StatIncreasePoints'
		},

		DismissPopupDialog:
		{
			Compensation: 'character-screen.dismiss-popup-dialog.Compensation'
		},

		BrothersListModule:
		{
            LevelUp: 'character-screen.brothers-list.LevelUp'
        }
	},

	ItemOwner:
	{
		Entity: 'entity',
		Ground: 'ground',
		Stash: 'stash'
	},

	ElementOwner:
	{
        HireScreen: 'hire-screen'
    }
};
